'From Smalltalk-80, version 2, of April 1, 1983 on 30 July 1986 at 10:56:09 am'!



!StandardSystemView methodsFor: 'framing'!

getFrame
	"Ask the user to designate a rectangular area in which the receiver should
	be displayed."

	| origin minimumCorner maximumCorner frame corner oldFrame mask |
	viewport isNil ifFalse: [Sensor primCursorLocPut: viewport origin].
	Sensor waitNoButton.
	Cursor origin
		showWhile: 
			[origin _ Sensor cursorPoint.
			[Sensor redButtonPressed]
				whileFalse: [Processor yield.
							 origin _ Sensor cursorPoint]].
	minimumCorner _ origin + self minimumSize.
	maximumCorner _ origin + self maximumSize.
	oldFrame _ frame _ origin corner: minimumCorner.
	mask _ Form veryLightGray.		"change form mask constant to suit your taste"
	Display fill: frame rule: Form reverse mask: mask.
	Display fill: frame rule: Form reverse mask: mask.
	minimumCorner = maximumCorner
		ifFalse: 
			[Sensor cursorPoint: minimumCorner.
				"highlight the minimum area"
			Display fill: frame rule: Form reverse mask: mask.
			Cursor corner
				showWhile: 
					[corner _ Sensor cursorPoint.
					[Sensor redButtonPressed]
						whileTrue: 
							[Processor yield.
								"get the new frame size"
							frame _ origin corner: (self computeFramePointFrom: corner max: maximumCorner min: minimumCorner).
							frame ~= oldFrame ifTrue:[
									"if different from the old highlight it"
								Display fill: oldFrame rule: Form reverse mask: mask.
								Display fill: frame rule: Form reverse mask: mask.
								oldFrame _ frame].
							corner _ Sensor cursorPoint]].
				"return the area back to normal"
			Display fill: frame rule: Form reverse mask: mask.].
	^frame!

computeFramePointFrom: aPoint max: maxCorner min: minCorner
	^(aPoint min: maxCorner) max: minCorner! !